package org.netkernel.lang.dpml.ast;

import org.netkernel.lang.dpml.endpoint.CompilerScope;
import org.netkernel.lang.dpml.endpoint.RuntimeState;
import org.netkernel.layer0.nkf.NKFException;

import java.util.Collection;

public interface IScope extends IVariable
{
	IVariable resolveAssignment(String aName, RuntimeState aState);
	
	IScope getParent();
	Collection<IVariable> getVariables();
	CompilerScope getCompilerScope();
	
	void addImport(IScope aImport, int aPrecedence);
	void addAssignment(IVariable aVariable, boolean aReplace) throws NKFException;
	void setResponse(IVariable aResponse);
}
