package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.ILocation;
import org.netkernel.lang.dpml.ast.IReferenceVariable;
import org.netkernel.lang.dpml.ast.IScope;
import org.netkernel.lang.dpml.ast.IVariable;
import org.netkernel.lang.dpml.endpoint.RuntimeState;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;


/** A reference to another assignment which must be dynamically resolved
 * @author Tony Butterfield
 *
 */
public class AssignmentReference extends VariableImpl implements IReferenceVariable
{	private final String mReference;
	
	public AssignmentReference(String aName, IScope aScope, ILocation aLocation, String aReference)
	{	super(aName,aScope,aLocation);
		mReference=aReference;
	}

	public String getReference()
	{	return mReference;
	}
	
	public IVariable resolve()
	{	//return getScope().resolveAssignment2(mReference);
		return null;
	}
	
	public IVariable resolve(INKFRequestContext aContext, RuntimeState aState) throws NKFException
	{	return getScope().resolveAssignment(mReference,aState);
	}

	public String toString()
	{	return "Ref["+mReference+"]";
	}
	
	public String getReferenceString()
	{	return mReference;
	}
}
