package org.netkernel.lang.dpml.endpoint;

import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.WrappedThrowable;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class ThrowAccessor extends StandardAccessorImpl
{
	public ThrowAccessor()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);
		declareArgument(new SourcedArgumentMetaImpl("id", "ID of thrown exception", null, new Class[]{String.class}));
		declareArgument(new SourcedArgumentMetaImpl("message", "descriptive message", null, new Class[]{String.class}));
		declareArgument(new SourcedArgumentMetaImpl("cause", "optional nested exception", null, new Class[]{Exception.class}));
		declareSourceRepresentation(java.lang.Exception.class);
		
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String id=aContext.source("arg:id",String.class);
		String message=null;
		if (aContext.getThisRequest().argumentExists("message"))
		{	message=aContext.source("arg:message",String.class);
		}
		Throwable cause=null;
		if (aContext.getThisRequest().argumentExists("cause"))
		{	WrappedThrowable wt=aContext.source("arg:cause",WrappedThrowable.class);
			cause=wt.getThrowable();
		}
		NKFException result= new NKFException(id,message,cause);
		aContext.createResponseFrom(result);
		
	}		
}
